# Esercizi di Assembly per CPU Sim

&copy; 2024 - prof. Roberto Fuligni

Materiale didattico per gli studenti dell'Istituto Tecnico Tecnologico "Giacomo Fauser" di Novara.

Soluzioni di alcuni degli esercizi di programmazione in Assembly per simulatore di CPU proposti dal 
libro di testo "Corso di Sistemi e reti (vol. 1)" (editore Zanichelli).

I programmi sono stati scritti con il software *Editor per CPU Sim* e possono contenere
commenti oppure etichette per le istruzioni di salto.

Per eseguire le istruzioni nel simulatore di CPU, si consiglia di aprire il programma con
*Editor per CPU Sim*, eseguire il comando **Copia e trasforma** e infine incollare il codice
trasformato nella sezione **code** del simulatore.

## Soluzioni degli esercizi del libro
* [Esercizio n. 13 pag. 53](libro/e13-quadrato.ed.txt) (Quadrato di un numero)
* [Esercizio n. 14 pag. 53](libro/e14-sommaquad.ed.txt) (Somma di quadrati)
* [Esercizio n. 16 pag. 53](libro/e16-multiplo7.ed.txt) (Multiplo di 7)
* [Esercizio n. 17 pag. 53](libro/e17-conta5.ed.txt) (Conta cifra 5)
* [Esercizio n. 18 pag. 53](libro/e18-potenza3.ed.txt) (Potenza di 3)
* [Esercizio n. 20 pag. 53](libro/e20-palindromo.ed.txt) (Vettore palindromo)

## Esercizi di programmazione in Assembly per CPU Sim

1. [[maggiore](es/maggiore)] - Dati 2 numeri interi a e b memorizzati nelle celle 100 e 101, determinare il 
   numero maggiore e memorizzare il risultato nella cella 102.

2. [[media](es/media)] - Dati 3 numeri memorizzati nelle celle 101, 102 e 103 determinare la media 
   aritmetica di tali numeri memorizzando il risultato nella cella 100. 
   (Nota: risolvere il problema senza ricorrere ai vettori).

3. [[produttoria](es/produttoria)] - Dato un vettore di N numeri, determinare la "*PRODUTTORIA*" degli elementi 
   memorizzando il risultato in un'opportuna cella di memoria.
   La produttoria è il risultato del prodotto di tutti gli elementi del vettore.

4. [[contaneg](es/contaneg)] - Dato un vettore di N numeri interi con segno (positivi, negativi o nulli), 
   contare il numero di valori negativi presenti nel vettore e memorizzare 
   il risultato nella cella 100.

5. [[multiplo5](es/multiplo5)] - Dato un numero N contenuto nella cella di memoria 100, determinare la cifra 
   delle unità memorizzandola nella cella 101.
   Successivamente, utilizzare tale cifra per stabilire se il numero N sia 
   un multiplo di 5.
   Se N è multiplo di 5, scrivere il numero 1 nella cella 102, altrimenti 
   scrivere 0.
